## ants 2.5.4+dfsg

=== CMakeLists.txt ===
set(ANTs_OLDEST_VALIDATED_POLICIES_VERSION "3.16.3")
set(ANTs_NEWEST_VALIDATED_POLICIES_VERSION "3.19.7")
cmake_minimum_required(VERSION ${ANTs_OLDEST_VALIDATED_POLICIES_VERSION}..${ANTs_NEWEST_VALIDATED_POLICIES_VERSION} FATAL_ERROR)

#####
##  Set the default target properties for ITK
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14) # Supported values are ``14``, ``17``, and ``20``.
endif()
# ==== Define language standard configurations requiring at least c++14 standard
if(CMAKE_CXX_STANDARD EQUAL "98" OR CMAKE_CXX_STANDARD LESS "14")
   message(FATAL_ERROR "C++98 to C++11 are no longer supported in ITK version 5.3 and greater.")
endif()
if(NOT CMAKE_CXX_STANDARD_REQUIRED)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()
if(NOT CMAKE_CXX_EXTENSIONS)
  set(CMAKE_CXX_EXTENSIONS OFF)
endif()

foreach(p
    ## Only policies introduced after the cmake_minimum_required
    ## version need to explicitly be set to NEW.
    )
  if(POLICY ${p})
    cmake_policy(SET ${p} NEW)
  endif()
endforeach()

set(LOCAL_PROJECT_NAME ANTS)
include(InstallRequiredSystemLibraries)
## NOTE THERE SHOULD BE NO PROJECT STATEMENT HERE!
## This file acts as a simple switch to initiate
## two completely independant CMake build environments.

#-----------------------------------------------------------------------------
# Superbuild Option - Enabled by default
#                   Phase I:  ${LOCAL_PROJECT_NAME}_SUPERBUILD is set to ON, and the
#                             supporting packages defined in "SuperBuild.cmake"
#                             are built.  The last package in "SuperBuild.cmake"
#                             to be built is a recursive call to this
#                             file with ${LOCAL_PROJECT_NAME}_SUPERBUILD explicitly
#                             set to "OFF" to initiate Phase II
#
#                   Phase II: Build the ${LOCAL_PROJECT_NAME}, referencing the support
#                             packages built in Phase I.
#-----------------------------------------------------------------------------
option(${LOCAL_PROJECT_NAME}_SUPERBUILD "Build ${LOCAL_PROJECT_NAME} and the projects it depends on via SuperBuild.cmake." ON)
mark_as_advanced(${LOCAL_PROJECT_NAME}_SUPERBUILD)

option(${LOCAL_PROJECT_NAME}_USE_QT "Find and use Qt with VTK to build GUI Tools" OFF)
mark_as_advanced(${LOCAL_PROJECT_NAME}_USE_QT)

option(${LOCAL_PROJECT_NAME}_INSTALL_DEVELOPMENT "Install development support include and libraries for external packages." OFF)
mark_as_advanced(${LOCAL_PROJECT_NAME}_INSTALL_DEVELOPMENT)

#-----------------------------------------------------------------------------
# Superbuild script
#-----------------------------------------------------------------------------
SET(CMAKE_INSTALL_PREFIX /opt/ANTs CACHE PATH "Default ANTs install path")
SET(SUPERBUILD_STAGING_PREFIX ${CMAKE_BINARY_DIR}/external)

if(${LOCAL_PROJECT_NAME}_SUPERBUILD)
  project(SuperBuild_${LOCAL_PROJECT_NAME}
    DESCRIPTION "Optional superbuild step to build external support libraries for ANTs"
  )
  include("${CMAKE_CURRENT_SOURCE_DIR}/SuperBuild.cmake")
  include(CPack)   # This must always be last!
  return()
else()
  project(${LOCAL_PROJECT_NAME}
    DESCRIPTION "Advanced Normalization Tools (ANTs) computes high-dimensional mappings to capture the statistics of brain structure and function."
    HOMEPAGE_URL "https://github.com/ANTsX/ANTs"
    LANGUAGES CXX C)
  include("${CMAKE_CURRENT_SOURCE_DIR}/${LOCAL_PROJECT_NAME}.cmake")
  include(CPack)   # This must always be last!
  return()
endif()

message(FATAL_ERROR "You should never reach this point !")

=== Examples/CMakeLists.txt ===
SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
## Note that the antsUtilities can always be built static.  It will then be linked
## Directly into the other libraries.
add_library(antsUtilities antsUtilities.cxx
            antsRegistrationTemplateHeader.cxx
            antsRegistration2DDouble.cxx antsRegistration2DFloat.cxx
            antsRegistration3DDouble.cxx antsRegistration3DFloat.cxx
            antsRegistration4DDouble.cxx antsRegistration4DFloat.cxx
            ../Utilities/ReadWriteData.cxx
            ../Utilities/antsCommandLineOption.cxx
            ../Utilities/antsCommandLineParser.cxx
            ANTsVersion.cxx
            ImageMathHelper2D.cxx ImageMathHelper3D.cxx ImageMathHelper4D.cxx
            )
target_link_libraries(antsUtilities ${ITK_LIBRARIES} )
install(TARGETS antsUtilities
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT RUNTIME_antsUtilities
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    COMPONENT RUNTIME_antsUtilities
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    COMPONENT DEVELOPMENT_antsUtilities
  )

macro(STATIC_ANTS_BUILD ANTS_FUNCTION_NAME EXTRA_LIBS)
  set( ANTS_FUNCTION_NAME ${ANTS_FUNCTION_NAME} )

  add_library(l_${ANTS_FUNCTION_NAME} ${ANTS_FUNCTION_NAME}.cxx)
  set_target_properties(l_${ANTS_FUNCTION_NAME} PROPERTIES
    SOVERSION ${ANTS_VERSION_MAJOR}  VERSION ${${PROJECT_NAME}_VERSION})
  message(STATUS "${ANTS_FUNCTION_NAME} ${EXTRA_LIBS}")
  target_link_libraries(l_${ANTS_FUNCTION_NAME} antsUtilities ${EXTRA_LIBS} )
  configure_file( template_for_executables.cxx.in cli_${ANTS_FUNCTION_NAME}.cxx )

  if (ANTS_INSTALL_LIBS_ONLY)
    install(TARGETS l_${ANTS_FUNCTION_NAME}
 #    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
 #    COMPONENT RUNTIME_${ANTS_FUNCTION_NAME}
      LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
      COMPONENT RUNTIME_${ANTS_FUNCTION_NAME}
      ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
      COMPONENT DEVELOPMENT_${ANTS_FUNCTION_NAME}
    )
  else()
    add_executable( ${ANTS_FUNCTION_NAME} cli_${ANTS_FUNCTION_NAME}.cxx )
    target_link_libraries( ${ANTS_FUNCTION_NAME} l_${ANTS_FUNCTION_NAME} )
    install(TARGETS l_${ANTS_FUNCTION_NAME} ${ANTS_FUNCTION_NAME}
      RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
      COMPONENT RUNTIME_${ANTS_FUNCTION_NAME}
      LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
      COMPONENT RUNTIME_${ANTS_FUNCTION_NAME}
      ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
      COMPONENT DEVELOPMENT_${ANTS_FUNCTION_NAME}
    )
  endif()

endmacro()

macro(DYNAMIC_ANTS_BUILD ANTS_FUNCTION_NAME EXTRA_LIBS)
  set( ANTS_FUNCTION_NAME ${ANTS_FUNCTION_NAME} )

  add_library(l_${ANTS_FUNCTION_NAME} ${ANTS_FUNCTION_NAME}.cxx)
  set_target_properties(l_${ANTS_FUNCTION_NAME} PROPERTIES
    SOVERSION ${ANTS_VERSION_MAJOR}  VERSION ${${PROJECT_NAME}_VERSION})
  message(STATUS "${ANTS_FUNCTION_NAME} ${EXTRA_LIBS}")
  target_link_libraries(l_${ANTS_FUNCTION_NAME} antsUtilities ${EXTRA_LIBS} )
  configure_file( template_for_executables.cxx.in cli_${ANTS_FUNCTION_NAME}.cxx )

  if (ANTS_INSTALL_LIBS_ONLY)
    install(TARGETS l_${ANTS_FUNCTION_NAME}
  #   RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  #   COMPONENT RUNTIME_${ANTS_FUNCTION_NAME}
      LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
      COMPONENT RUNTIME_${ANTS_FUNCTION_NAME}
      ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
      COMPONENT DEVELOPMENT_${ANTS_FUNCTION_NAME}
  )
  else()
    add_executable( ${ANTS_FUNCTION_NAME} cli_${ANTS_FUNCTION_NAME}.cxx )
    target_link_libraries( ${ANTS_FUNCTION_NAME} l_${ANTS_FUNCTION_NAME} )

    install(TARGETS l_${ANTS_FUNCTION_NAME} ${ANTS_FUNCTION_NAME}
      RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
      COMPONENT RUNTIME_${ANTS_FUNCTION_NAME}
      LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
      COMPONENT RUNTIME_${ANTS_FUNCTION_NAME}
      ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
      COMPONENT DEVELOPMENT_${ANTS_FUNCTION_NAME}
    )
  endif()

endmacro()


#set(PROG_WITH_NO_FLAG simpleSynRegistration)
#add_executable(${PROG_WITH_NO_FLAG} ${PROG_WITH_NO_FLAG}.cxx)
#target_link_libraries(${PROG_WITH_NO_FLAG} antsUtilities ${ITK_LIBRARIES})


set(CORE_ANTS_APPS
  antsAffineInitializer
  antsJointFusion
  DenoiseImage
  SurfaceBasedSmoothing
  ThresholdImage
  ResampleImage
  sccan
  N4BiasFieldCorrection
  N3BiasFieldCorrection
  KellyKapowski
  antsRegistration
  antsMotionCorrStats
  antsMotionCorr
  antsApplyTransforms
  LabelGeometryMeasures
  LabelClustersUniquely
  Atropos
  antsApplyTransformsToPoints
)

set(MORE_ANTS_APPS
    antsAI
    ANTSIntegrateVelocityField
    antsJointTensorFusion
    ImageMath
    iMath
    AddNoiseToImage
    ANTS
    ANTSJacobian
    CreateJacobianDeterminantImage
    PrintHeader
    ResetDirection
    ANTSUseLandmarkImagesToGetAffineTransform
    ANTSUseLandmarkImagesToGetBSplineDisplacementField
    ANTSUseDeformationFieldToGetAffineTransform
    antsLandmarkBasedTransformInitializer
    LaplacianThickness
    SetOrigin
    SetSpacing
    SetDirectionByMatrix
    SurfaceCurvature
    ConvertScalarImageToRGB
    CreateWarpedGridImage
    MeasureImageSimilarity
    ConvertToJpg
    ConvertImage
    ConvertImagePixelType
    ConvertInputImagePixelTypeToFloat
    FitBSplineToPoints
    AverageTensorImages
    ImageSetStatistics
    MultiplyImages
    SimulateDisplacementField
    SmoothDisplacementField
    SmoothImage
    ClusterImageStatistics
    LabelOverlapMeasures
    LesionFilling
    MeasureMinMaxMean
    WarpImageMultiTransform
    ComposeMultiTransform
    MemoryTest
    PermuteFlipImageOrientationAxes
    ImageCompare
    ResampleImageBySpacing
    CopyImageHeaderInformation
    WarpTimeSeriesImageMultiTransform
    ExtractSliceFromImage
    ExtractRegionFromImage
    ExtractRegionFromImageByMask
    PasteImageIntoImage
    TileImages
    CreateTiledMosaic
    CreateImage
    NonLocalSuperResolution
    WarpTensorImageMultiTransform
    ReorientTensorImage
    RebaseTensorImage
    KellySlater
    CreateDTICohort
    antsAlignOrigin
    antsMotionCorrDiffusionDirection
    antsSliceRegularizedRegistration
    ANTSIntegrateVectorField
    antsTransformInfo
    antsUtilitiesTesting
    AverageAffineTransform
    AverageAffineTransformNoRigid
    AverageImages
    simpleSynRegistration
    CompositeTransformUtil
    CreateDisplacementField
    ConvertTransformFile
    compareTwoTransforms
    SuperResolution
    TimeSCCAN
    TextureCooccurrenceFeatures
    TextureRunLengthFeatures
    ImageIntensityStatistics
    GetConnectedComponentsFeatureImages
    DeNrrd
    StackSlices
  )

foreach(ANTS_APP ${CORE_ANTS_APPS})
  if (BUILD_SHARED_LIBS)
    DYNAMIC_ANTS_BUILD(${ANTS_APP} "")
  else()
    STATIC_ANTS_BUILD(${ANTS_APP} "")
  endif()
endforeach()

if (BUILD_ALL_ANTS_APPS)
  foreach(ANTS_APP ${MORE_ANTS_APPS})
    if (BUILD_SHARED_LIBS)
     DYNAMIC_ANTS_BUILD(${ANTS_APP} "")
    else()
      STATIC_ANTS_BUILD(${ANTS_APP} "")
    endif()
  endforeach()
else()
  foreach(ANTS_APP ${MORE_ANTS_APPS})
    if(ANTS_BUILD_${ANTS_APP})
      if (BUILD_SHARED_LIBS)
        DYNAMIC_ANTS_BUILD(${ANTS_APP} "")
      else()
        STATIC_ANTS_BUILD(${ANTS_APP} "")
      endif()
    endif()
  endforeach()
endif()


if(USE_VTK)
set(VTK_ANTS_APPS
    # ConvertVectorFieldToVTK
    antsSurf
    antsVol
    GetMeshAndTopology
    CheckTopology
    WarpVTKPolyDataMultiTransform
    # FLATFEM
    # ConformalMapping
    # ANTSConformalMapping
  )

foreach(ANTS_APP ${VTK_ANTS_APPS})

  if (BUILD_SHARED_LIBS)
    DYNAMIC_ANTS_BUILD(${ANTS_APP} "${VTK_LIBRARIES}")
  else()
    STATIC_ANTS_BUILD(${ANTS_APP} "${VTK_LIBRARIES}")
  endif()

endforeach()
endif()

## Build test option
if(BUILD_TESTING)
    add_subdirectory(TestSuite)
endif()

=== antsRegistrationCLP/CMakeLists.txt ===

find_package(SlicerExecutionModel REQUIRED GenerateCLP)
include(${GenerateCLP_USE_FILE})

set(antsRegistrationCLP_SOURCE antsRegistrationCLP.cxx)

generateclp(antsRegistrationCLP_SOURCE antsREGISTRATIONCLP.xml)

add_executable(antsRegistrationCLP ${antsRegistrationCLP_SOURCE})

target_link_libraries(antsRegistrationCLP ${ITK_LIBRARIES})

=== Examples/TestSuite/CMakeLists.txt ===
###############################################################################
###############################################################################
## MakeTestDriverFromANTSbinary
## For tools made with the slicer execution model,
## This macro will build a test driver that adds the
## --compare
## --compareIntensityTolerance
## --compareRadiusTolerance
## --compareNumberOfPixelsTolerance
## to the SEM tools.
macro(MakeTestDriverFromANTSbinary ANTSbinaryName ANTSbinaryTestSourceName ANTS_FUNCTION_NAME)

  set(CMAKE_TESTDRIVER_BEFORE_TESTMAIN "#include \"itkTestDriverBeforeTest.inc\"")
  set(CMAKE_TESTDRIVER_AFTER_TESTMAIN "#include \"itkTestDriverAfterTest.inc\"")

  set(ANTS_FUNCTION_NAME ${ANTS_FUNCTION_NAME})
  configure_file( template_for_executableTestWrapper.cxx.in ${ANTSbinaryTestSourceName} )

  include_directories(${ITK_INCLUDE_DIRS})
  create_test_sourcelist(${ANTSbinaryName}   ${ANTSbinaryName}Driver.cxx ${ANTSbinaryTestSourceName}
     EXTRA_INCLUDE itkTestDriverIncludeRequiredIOFactories.h
     FUNCTION  ProcessArgumentsAndRegisterRequiredFactories
     )

  add_executable(${ANTSbinaryName}Driver ${ANTSbinaryName}Driver.cxx ${ANTSbinaryTestSourceName})
  target_link_libraries(${ANTSbinaryName}Driver l_${ANTS_FUNCTION_NAME} )
  set_target_properties(${ANTSbinaryName}Driver PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    LIBRARY_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    )
endmacro()

#-----------------------------------------------------------------------
# Setup locations to find externally maintained test data.
#-----------------------------------------------------------------------
include(ANTSExternalData)

# Tell ExternalData commands to transform raw files to content links.
set(ExternalData_LINK_CONTENT SHA512)
set(ExternalData_SOURCE_ROOT ${${PROJECT_NAME}_SOURCE_DIR})
include(ExternalData)


# Set testing environment
set(ANTS_TEST_BIN_DIR ${CMAKE_BINARY_DIR}/Examples)

set(TEST_DATA_DIR ${CMAKE_SOURCE_DIR}/TestData)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/TEST_LOCATION)

## Test antsRegistration
##
file(GLOB_RECURSE INCS ${CMAKE_SOURCE_DIR}/Examples/"*.h")

MakeTestDriverFromANTSbinary(antsRegistrationTest antsRegistrationTest.cxx antsRegistration)
MakeTestDriverFromANTSbinary(antsApplyTransformsTest antsApplyTransformsTest.cxx antsApplyTransforms)


###
#  Perform testing
###
set(TestDataSHA512_DIR ${CMAKE_SOURCE_DIR}/TestData)
set(SMALL_DATA_DIR ${TestDataSHA512_DIR}/Data)

ExternalData_expand_arguments(${PROJECT_NAME}FetchData R16_IMAGE DATA{${SMALL_DATA_DIR}/r16slice.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData R64_IMAGE DATA{${SMALL_DATA_DIR}/r64slice.nii.gz})
###
# PSE sub-tests:  Check to see if .txt files and .vtk files also run correctly
###
ExternalData_expand_arguments(${PROJECT_NAME}FetchData DEVIL_IMAGE DATA{${SMALL_DATA_DIR}/Frown.nii})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData ANGEL_IMAGE DATA{${SMALL_DATA_DIR}/Smile.nii})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData DEVIL_IMAGE_TXT DATA{${SMALL_DATA_DIR}/Frown.txt})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData ANGEL_IMAGE_TXT DATA{${SMALL_DATA_DIR}/Smile.txt})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData DEVIL_IMAGE_VTK DATA{${SMALL_DATA_DIR}/Frown.vtk})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData ANGEL_IMAGE_VTK DATA{${SMALL_DATA_DIR}/Smile.vtk})
#ExternalData_expand_arguments(${PROJECT_NAME}FetchData SEG_IMAGE DATA{${SMALL_DATA_DIR}/nslice.nii.gz})

if(RUN_LONG_TESTS)

## A work around for the crazy ANTS command line that is not compatible
## with the testing framework of external tests

ExternalData_expand_arguments(${PROJECT_NAME}FetchData test_mask_VAR DATA{${TestDataSHA512_DIR}/test_mask.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData scale_test_mask_VAR DATA{${TestDataSHA512_DIR}/scale.test_mask.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData rotation_test_mask_VAR DATA{${TestDataSHA512_DIR}/rotation.test_mask.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData translation_test_mask_VAR DATA{${TestDataSHA512_DIR}/translation.test_mask.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData test_image_VAR DATA{${TestDataSHA512_DIR}/test.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData scale_test_image_VAR DATA{${TestDataSHA512_DIR}/scale.test.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData rotation_test_image_VAR DATA{${TestDataSHA512_DIR}/rotation.test.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData rotation_geom_test_image_VAR DATA{${TestDataSHA512_DIR}/rotation.geom.test.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData translation_test_image_VAR DATA{${TestDataSHA512_DIR}/translation.test.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData translation_rescale_test_image_VAR DATA{${TestDataSHA512_DIR}/translation.rescale.test.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData rotation_rescale_test_image_VAR DATA{${TestDataSHA512_DIR}/rotation.rescale.test.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData ANON0006_20_T1_dbg_splayed_image_VAR DATA{${TestDataSHA512_DIR}/ANON0006_20_T1_dbg_splayed.nii.gz})
ExternalData_expand_arguments(${PROJECT_NAME}FetchData ANON0006_20_T1_sag_twisted_image_VAR DATA{${TestDataSHA512_DIR}/ANON0006_20_T1_sag_twisted.nii.gz})

set(antsRegistrationTestName antsRegistrationTest_AffineScaleMasks)
ExternalData_add_test( ${PROJECT_NAME}FetchData NAME ${antsRegistrationTestName}
  COMMAND ${LAUNCH_EXE} antsRegistrationTestDriver
  --compare DATA{${TestDataSHA512_DIR}/${antsRegistrationTestName}.result.nii.gz}
            ${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz
  --compareIntensityTolerance 9
  --compareRadiusTolerance 0
  --compareNumberOfPixelsTolerance 1000

  antsRegistrationTest
  -v --dimensionality 3
  --convergence 25x20x5 #numberOfIterations 2500
  --shrink-factors 1x1x1
  --smoothing-sigmas 0.1x0.1x0.1
  --metric Mattes[${test_image_VAR},${scale_test_image_VAR},1,200,Regular,0.10] #costMetric & fixedVolume & movingVolume & metricWeight? & numberOfHistogramBins & samplingStrategy? & samplingPercentage(numberOfSamples)
  --transform "Affine[0.001]" #transformType & minimumStepLength
  --initial-moving-transform DATA{${TestDataSHA512_DIR}/Initializer_0.05_${antsRegistrationTestName}.mat}
  --masks [${test_mask_VAR},${scale_test_mask_VAR}] #fixedBinaryVolume & movingBinaryVolume
  --output [${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName},${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz,${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}_inverse.test.nii.gz]
)

set(antsRegistrationTestName antsRegistrationTest_AffineScaleNoMasks)
ExternalData_add_test( ${PROJECT_NAME}FetchData NAME ${antsRegistrationTestName}
  COMMAND ${LAUNCH_EXE} antsRegistrationTestDriver
  --compare DATA{${TestDataSHA512_DIR}/${antsRegistrationTestName}.result.nii.gz}
            ${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz
  --compareIntensityTolerance 9
  --compareRadiusTolerance 0
  --compareNumberOfPixelsTolerance 1000

  antsRegistrationTest
  -v --dimensionality 3
  --convergence 25x20x5
  --shrink-factors 1x1x1
  --smoothing-sigmas 0.1x0.1x0.1
  -u
  --metric Mattes[${test_image_VAR},${scale_test_image_VAR},1,200,Regular,0.10]
  --transform "Affine[0.001]" #transformType & minimumStepLength
  --initial-moving-transform DATA{${TestDataSHA512_DIR}/Initializer_0.05_antsRegistrationTest_AffineScaleMasks.mat}
  --output [${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName},${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz]
)

set(antsRegistrationTestName antsRegistrationTest_AffineRotationMasks)
ExternalData_add_test( ${PROJECT_NAME}FetchData NAME ${antsRegistrationTestName}
  COMMAND ${LAUNCH_EXE} antsRegistrationTestDriver
  --compare DATA{${TestDataSHA512_DIR}/${antsRegistrationTestName}.result.nii.gz}
            ${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz
  --compareIntensityTolerance 25
  --compareRadiusTolerance 1
  --compareNumberOfPixelsTolerance 1000

  antsRegistrationTest
  -v --dimensionality 3
  --convergence 25x20x5
  --shrink-factors 1x1x1
  --smoothing-sigmas 0.1x0.1x0.1
  --metric Mattes[${test_image_VAR},${rotation_test_image_VAR},1,200,Regular,0.10]
  --transform "Affine[0.001]"
  --initial-moving-transform DATA{${TestDataSHA512_DIR}/Initializer_0.05_${antsRegistrationTestName}.mat}
  --masks [${test_mask_VAR},${rotation_test_mask_VAR}]
  --output [${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName},${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz]
)

set(antsRegistrationTestName antsRegistrationTest_AffineRotationNoMasks)
ExternalData_add_test( ${PROJECT_NAME}FetchData NAME ${antsRegistrationTestName}
  COMMAND ${LAUNCH_EXE} antsRegistrationTestDriver
  --compare DATA{${TestDataSHA512_DIR}/${antsRegistrationTestName}.result.nii.gz}
            ${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz
  --compareIntensityTolerance 7
  --compareRadiusTolerance 0
  --compareNumberOfPixelsTolerance 777

  antsRegistrationTest
  -v --dimensionality 3
  --convergence 25x20x5
  --shrink-factors 1x1x1
  --smoothing-sigmas 0.1x0.1x0.1
  --metric Mattes[${test_image_VAR},${rotation_test_image_VAR},1,200,Regular,0.10]
  --transform "Affine[0.001]"
  --initial-moving-transform DATA{${TestDataSHA512_DIR}/Initializer_0.05_${antsRegistrationTestName}.mat}
  --output [${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName},${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz]
)

set(antsRegistrationTestName antsRegistrationTest_AffineTranslationMasks)
ExternalData_add_test( ${PROJECT_NAME}FetchData NAME ${antsRegistrationTestName}
  COMMAND ${LAUNCH_EXE} antsRegistrationTestDriver
  --compare DATA{${TestDataSHA512_DIR}/${antsRegistrationTestName}.result.nii.gz}
            ${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz
  --compareIntensityTolerance 7
  --compareRadiusTolerance 0
  --compareNumberOfPixelsTolerance 777

  antsRegistrationTest
  -v --dimensionality 3
  --convergence 25x20x5
  --shrink-factors 1x1x1
  --smoothing-sigmas 0.1x0.1x0.1
  --metric MeanSquares[${test_image_VAR},${translation_test_image_VAR},1,radius=NA,Regular,0.10]
  --transform "Affine[0.001]"
  --initial-moving-transform DATA{${TestDataSHA512_DIR}/Initializer_${antsRegistrationTestName}.mat}
  --masks [${test_mask_VAR},${translation_test_mask_VAR}]
  --output [${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName},${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz]
)

set(antsRegistrationTestName antsRegistrationTest_AffineTranslationNoMasks)
ExternalData_add_test( ${PROJECT_NAME}FetchData NAME ${antsRegistrationTestName}
  COMMAND ${LAUNCH_EXE} antsRegistrationTestDriver
  --compare DATA{${TestDataSHA512_DIR}/${antsRegistrationTestName}.result.nii.gz}
            ${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz
  --compareIntensityTolerance 7
  --compareRadiusTolerance 0
  --compareNumberOfPixelsTolerance 777

  antsRegistrationTest
  -v --dimensionality 3
  --convergence 25x20x5
  --shrink-factors 1x1x1
  --smoothing-sigmas 0.1x0.1x0.1
  --metric MeanSquares[${test_image_VAR},${translation_test_image_VAR},1,radius=NA,Regular,0.10]
  --transform "Affine[0.001]"
  --initial-moving-transform DATA{${TestDataSHA512_DIR}/Initializer_antsRegistrationTest_AffineTranslationMasks.mat}
  --output [${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName},${CMAKE_CURRENT_BINARY_DIR}/${antsRegistrationTestName}.test.nii.gz]
)

set(antsRegistrationTestName antsRegistrationTest_RigidAnisotropicMasks)
ExternalData_add_test( ${PROJECT_NAME}FetchData NAME ${antsRegistrationTestName}
  COMMAND ${LAUNCH_EXE} antsRegistrationTestDriver

=== debian/changelog ===
ants (2.5.4+dfsg-1) unstable; urgency=medium

  [ Steve Robbins ]
  * [9bc7d99] New upstream version 2.5.4+dfsg.  (Closes: #1094896)
  * [db3cd26] Refresh patches.
  * [44d1203] Update files list.

 -- Steve M. Robbins <smr@debian.org>  Tue, 11 Feb 2025 23:12:16 -0600

=== debian/control ===
Source: ants
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>,
           Michael Hanke <michael.hanke@gmail.com>,
           Pierre Gruet <pgt@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               help2man,
               cmake,
               libinsighttoolkit5-dev,
               uuid-dev,
               libboost-dev,
               libitkadaptivedenoising-dev,
               libitkgenericlabelinterpolator-dev,
               libtiff-dev,
               libdcmtk-dev | libdcmtk2-dev,
               libfftw3-dev,
               libhdf5-dev,
               libpng-dev
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/med-team/ants
Vcs-Git: https://salsa.debian.org/med-team/ants.git
Homepage: http://www.picsl.upenn.edu/ANTS/
Rules-Requires-Root: no

Package: ants
Architecture: any
Depends: ${shlibs:Depends},
         ${perl:Depends},
         ${misc:Depends}
Recommends: environment-modules
Suggests: fsl,
          gridengine-client,
          r-base-core
Conflicts: gpe-conf
Description: advanced normalization tools for brain and image analysis
 Advanced Normalization Tools (ANTS) is an ITK-based suite of
 normalization, segmentation and template-building tools for
 quantitative morphometric analysis. Many of the ANTS registration
 tools are diffeomorphic, but deformation (elastic and BSpline)
 transformations are available. Unique components of ANTS include
 multivariate similarity metrics, landmark guidance, the ability to
 use label images to guide the mapping and both greedy and space-time
 optimal implementations of diffeomorphisms. The symmetric
 normalization (SyN) strategy is a part of the ANTS toolkit as is
 directly manipulated free form deformation (DMFFD).
 .
 This package provides environment-modules configuration.
 Use 'module load ants' to make all cmdline tools available in your shell.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

modulesfile = debian/ants.environment-modules

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# Exclude all heavy tests while building on slowish build
# bots/platforms
BOGOMIPS = $(shell awk '/^bogomips/{print $$3;}' /proc/cpuinfo | sed -ne '1s,\..*,,gp' )
CTEST_EXCLUDE = $(shell [ "$(BOGOMIPS)" -gt 2000 ] || echo "-E '^ANTS(_|PSE)'")

export SHELL=/bin/bash

# Default mega-rule
%:
	dh $@


override_dh_auto_configure:
	dh_auto_configure -- \
		-DANTS_SUPERBUILD:BOOL=OFF \
		-DANTS_USE_GIT_PROTOC:BOOL=OFF \
		-DCOPY_SCRIPT_FILES_TO_BIN_DIR:BOOL=OFF \
		-DCMAKE_SKIP_RPATH:BOOL=OFF \
		-DUSE_SYSTEM_ITK:BOOL=ON \
		-DUSE_VTK:BOOL=OFF \
		-DBUILD_SHARED_LIBS:BOOL=ON \
		-DRUN_SHORT_TESTS:BOOL=ON \
		-DRUN_LONG_TESTS:BOOL=OFF \
		-DEXECUTABLE_OUTPUT_PATH:PATH=$(DESTBINDIR) \
		-DCMAKE_INSTALL_RPATH:STRING="/usr/lib/ants/lib" \
		--debug-output

%modules: %modules.in
	sed -e 's,$$UVERSION,$(DEB_VERSION_UPSTREAM),g' $< >| $@

override_dh_auto_build: $(modulesfile)
	dh_auto_build

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd obj-*; \
	 ctest --force-new-ctest-process $(CTEST_EXCLUDE)
endif

override_dh_auto_install:
	dh_auto_install
	: Move binaries under usr/lib/ants
	mv debian/ants/usr/bin/* debian/ants/usr/lib/ants
	: Move shared libs under usr/lib/ants/lib
	mkdir -p debian/ants/usr/lib/ants/lib
	mv debian/ants/usr/lib/$(DEB_HOST_MULTIARCH)/* debian/ants/usr/lib/ants/lib
	rm -rf debian/ants/usr/lib/$(DEB_HOST_MULTIARCH)/
	: Symlink binaries of primary importance and with ants prefix into /usr/bin, skipping .sh suffix
	for fp in debian/ants/usr/lib/ants/{ants*,ANTS*,WarpImageMultiTransform,WarpTimeSeriesImageMultiTransform,Atropos,LaplacianThickness}; do \
		f=$$(basename $$fp); \
		dh_link usr/lib/ants/$$f usr/bin/$${f%.sh}; \
	done
	: Install shell scripts
	install -t debian/ants/usr/lib/ants Scripts/*
	: Install modules file
	install -m 664 $(modulesfile) debian/ants/usr/share/modules/modulefiles/ants/$(DEB_VERSION_UPSTREAM)
	: Adjust ANTSPATH
	cd debian/ants/usr/lib/ants && sed -ie 's,\([^"=]*\(/bin/ants\|ANTS/release/bin\)\),/usr/lib/ants,g' *.sh *.pl && rm *.she *.ple

override_dh_installman:
	: Create and install manpages for scripts symlinked from /usr/bin
	# Putting the path to shared libs in LD_LIBRARY_PATH so that calls to
	# executable files by help2man succeed.
	cd debian/ants/usr/bin && mkdir -p ../../../../manGen && \
    for f in *; do \
	 LD_LIBRARY_PATH="${LD_LIBRARY_PATH}:../lib/ants/lib" \
	 help2man --name="part of ANTS registration suite" --version-string $(DEB_VERSION_UPSTREAM) \
	          --no-info --no-discard-stderr ./$$f >| ../../../../manGen/$$f.1; \
     done
	dh_installman manGen/*

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDDIR) debian/ants.environment-modules manGen/

=== debian/watch ===
version=4
opts="repack, repacksuffix=+dfsg, compression=xz, dversionmangle=auto, \
 uversionmangle=s/rc/~rc/g,filenamemangle=s/.*\/(.*)/ants-$1/" \
  https://github.com/ANTsX/ANTs/tags (?:.*?/)?v?([\d\.a-z]+)\.tar\.gz

## ants 2.6.4+dfsg

=== debian/changelog ===
ants (2.6.4+dfsg-1) unstable; urgency=medium

  * New upstream version 2.6.4+dfsg
  * Refreshing patches
  * Raising Standards version to 4.7.3:
    - Removing Priority: optional, which is default
    - Removing R-R-R: no, which is default
  * Removing Suggests: of unexisting package fsl (Closes: #1117158)
  * Rewriting d/watch with version 5

 -- Pierre Gruet <pgt@debian.org>  Fri, 26 Dec 2025 22:09:30 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,6 @@
            Michael Hanke <michael.hanke@gmail.com>,
            Pierre Gruet <pgt@debian.org>
 Section: science
-Priority: optional
 Build-Depends: debhelper-compat (= 13),
                help2man,
                cmake,
@@ -18,11 +17,10 @@
                libfftw3-dev,
                libhdf5-dev,
                libpng-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/med-team/ants
 Vcs-Git: https://salsa.debian.org/med-team/ants.git
 Homepage: http://www.picsl.upenn.edu/ANTS/
-Rules-Requires-Root: no
 
 Package: ants
 Architecture: any
@@ -30,8 +28,7 @@
          ${perl:Depends},
          ${misc:Depends}
 Recommends: environment-modules
-Suggests: fsl,
-          gridengine-client,
+Suggests: gridengine-client,
           r-base-core
 Conflicts: gpe-conf
 Description: advanced normalization tools for brain and image analysis

=== debian/watch ===
Version: 5

Source: https://github.com/ANTsX/ANTs/tags
Matching-Pattern: (?:.*?/)?v?([\d\.a-z]+)\.tar\.gz
Compression: xz
Dversionmangle: auto
Filenamemangle: s/.*\/(.*)/ants-$1/
Repack: yes
Repacksuffix: +dfsg
Uversionmangle: s/rc/~rc/g
